'use strict';

var fs = require('fs');
var path = require('path');
var lodash = require('lodash');
var userhome = require('userhome');

function HomeConfig(a) {
  a = a || {};

  var b = a.environmentVar || 'NODE_DEVEBOT_CLI';
  var c = process.env[b];
  var d = a.configSubdir || '.devebot';
  var e = a.configFilename || 'config';
  var f = lodash.merge({
    protocol: 'http',
    host: '0.0.0.0',
    port: 17779,
    path: '/devebot',
    authen: {
      token_key: "devebot",
      token_secret: "s3cr3tpa$$w0rd"
    },
    tunnel: {
      enabled: true,
      rejectUnauthorized: false
    }
  }, a.defaultConfig);

  var g = this;

  var h = userhome(d);
  try {
    fs.readdirSync(h);
  } catch (a) {
    if (a.code == 'ENOENT') {
      fs.mkdirSync(h);
    }
  }

  var i = function readConfigFile(a, b, c) {
    var d = a;

    var f = [e];
    if (lodash.isString(c) && c.length > 0) {
      f.push('.', c);
    }
    f.push('.json');
    var g = path.join(b, f.join(''));

    try {
      d = JSON.parse(fs.readFileSync(g, 'utf8'));
    } catch (a) {
      if (a.code == 'ENOENT') {
        fs.writeFileSync(g, JSON.stringify(d, null, 2), 'utf8');
      }
    }
    return d;
  };

  var j = i(f, h);

  g.getContext = function () {
    return c;
  };

  g.getConfig = function () {
    if (lodash.isString(c) && !lodash.isEmpty(c)) {
      g.loadConfig(c);
    }
    return lodash.clone(j, true);
  };

  g.loadConfig = function (a) {
    if (!lodash.isString(a)) return;
    j = lodash.defaultsDeep(i({}, h, a), j);
  };

  g.saveConfig = function (a, b) {
    if (!lodash.isString(a) || a.length == 0) return;
    var c = path.join(h, 'config.' + a + '.json');

    if (!lodash.isObject(b)) return;
    j = lodash.defaultsDeep(b, j);

    fs.writeFileSync(c, JSON.stringify(j, null, 2), 'utf8');
  };
}

module.exports = HomeConfig;