'use strict';

var util = require('util');

function Perf() {
  this.hrstart = process.hrtime();
}

Perf.prototype.stop = function () {
  var a = process.hrtime(this.hrstart);
  var b = process.memoryUsage().rss;
  return {
    time_usage: a,
    time_text: util.format('%ds %dms', a[0], a[1] / 1000000),
    memory_usage: b,
    memory_text: util.format('%d(MB)', Math.round(b / 1024 / 1024))
  };
};

module.exports = Perf;